<?php
//File: LotteryDraw.php
//      Lottery feature. Lottery drawing

//VERSION: 1.0.0
//DATE: Oct 31st, 2007
// $Id: LotteryDraw.php YamiKaitou $

require(dirname(__FILE__) . '/../../SSI.php');
require(dirname(__FILE__) . '/Shop-Subs.php');
require(dirname(__FILE__) . '/../Subs-Post.php');

global $db_prefix;

// Make sure that it has been at least 6 days since the last drawing. Time is changable, look at the next comment
$result = db_query("SELECT `value` FROM {$db_prefix}settings WHERE `variable` = 'lottery_last_draw'",__FILE__,__LINE__);
$last_draw = mysql_result($result,0);
$currentTime = time();
mysql_free_result($result);
// 518400 is the amount of seconds in 6 days. Change this to change the time between the draws.
if ($currentTime - $last_draw < 518400)
	fatal_error("Lottery draws are to close together.",true);

//Update new last draw time
db_query("UPDATE {$db_prefix}settings SET `value` = '$currentTime' WHERE `variable` = 'lottery_last_draw'",__FILE__,__LINE__);

// Get last ticket for this drawing
$result = db_query("SELECT `ID_TICKET` FROM {$db_prefix}shop_lottery  ORDER BY `ID_TICKET` DESC",__FILE__,__LINE__);
$lastTicket = mysql_result($result,0);
mysql_free_result($result);

// Get jackpot
$result = db_query("SELECT `value` FROM {$db_prefix}settings WHERE `variable` = 'lottery_pot'",__FILE__,__LINE__);
$jackpot = mysql_result($result,0);
mysql_free_result($result);

// Get max range of ball values and get PM From data
$result = db_query("SELECT `info2`, `info4` FROM {$db_prefix}shop_items WHERE `module` = 'lottery'",__FILE__,__LINE__);
$max = mysql_result($result,0,'info2');
$sender = mysql_result($result,0,'info4');
mysql_free_result($result);

// Set up initial draw
$winning = array(
    0 => 0,
	1 => rand(1,$max),
	2 => rand(1,$max),
	3 => rand(1,$max),
	4 => rand(1,$max),
);

// Check to make sure there was not 2 of the same ball drawn
while (
$winning[1] == $winning[2] OR 
$winning[1] == $winning[3] OR 
$winning[1] == $winning[4] OR 
$winning[2] == $winning[3] OR 
$winning[2] == $winning[4] OR 
$winning[3] == $winning[4])
{
	if ($winning[1] == $winning[2])
		$winning[2] = rand(1,$max);
	elseif ($winning[1] == $winning[3])
		$winning[3] = rand(1,$max);
	elseif ($winning[1] == $winning[4])
		$winning[4] = rand(1,$max);
	elseif ($winning[2] == $winning[3])
		$winning[3] = rand(1,$max);
	elseif ($winning[2] == $winning[4])
		$winning[4] = rand(1,$max);
	elseif ($winning[3] == $winning[4])
		$winning[4] = rand(1,$max);
}

// Sort array
array_multisort($winning,SORT_ASC);

// Find the winners

// First we need to know what the last ticket for the last drawing was
$result = db_query("SELECT `lastTicket` FROM {$db_prefix}lottery_win ORDER BY `ID_DRAWING` DESC",__FILE__,__LINE__);
if (mysql_num_rows($result) == 0)
    $startTicket = 1;
else
    $startTicket = mysql_result($result,0) + 1;
mysql_free_result($result);

// Now, we match them with the winning numbers
// At this time, they must have all numbers to win
$result = db_query("SELECT `ID_TICKET`, `ID_MEMBER` FROM {$db_prefix}shop_lottery 
WHERE `Ball1` = '{$winning[1]}' AND 
`Ball2` = '{$winning[2]}' AND 
`Ball3` = '{$winning[3]}' AND 
`Ball4` = '{$winning[4]}'",__FILE__,__LINE__);
$numWinners = 0;
while($row = mysql_fetch_array($result))
    if ($row['ID_TICKET'] >= $startTicket AND $row['ID_TICKET'] <= $lastTicket)
    {
        $winners[$numWinners]['ticket'] = $row['ID_TICKET'];
        $winners[$numWinners++]['member'] = $row['ID_MEMBER'];
    }

// Figure out how much each winner gets
if ($numWinners == 0)
    $jackpot = 0;
else
    $each = $jackpot / $numWinners;

// Give the winners their share of the jackpot
for ($k = 0; $k < $numWinners; $k++)
    db_query("UPDATE {$db_prefix}members SET `money` = `money` + $each WHERE `ID_MEMBER` = {$winners[$k]['member']}",__FILE__,__LINE__);

// Create/Get data for sender of PM. Advoiding extra queries to database
if ($sender == 0)
    // Sending PM from a guest named "Lottery Admin"
    $from = array(
        'id' => 0,
        'name' => 'Lottery Admin',
        'username' => 'Lottery Admin'
    );
else
{
    // Get data for defined sender
    $result = db_query("SELECT `memberName`, `realName` FROM {$db_prefix}members WHERE `ID_MEMBER` =$sender",__FILE__,__LINE__);
    $from['id'] = $sender;
    $from['name'] = mysql_result($result,0,'realName');
    $from['username'] = mysql_result($result,0,'memberName');
    mysql_free_result($result);
}

// Send a PM to them telling them that they won
for ($k = 0; $k < $numWinners; $k++)
{
    // Get data for recipient
    $recipients = array(
		'to' => array(),
		'bcc' => array()
	);
    $recipients['to'][] = $winners[$k]['member'];
    
    // Create body of PM
    $message = "[b]Congratulations!![/b]

One of your tickets won todays drawing (ticket id {$winners[$k]['ticket']}). You have been given ".formatMoney($each)." for this ticket.

-Lottery Admin";
    
    // Send PM
    $pmresults = sendpm($recipients, "YOU WON THE LOTTERY THIS DRAW!!", $message, false, $from);
}

// Set the jackpot total back to the default 1000 if needed
if ($jackpot != 0)
    db_query("UPDATE {$db_prefix}settings SET `value` = 1000 WHERE `variable` = 'lottery_pot'",__FILE__,__LINE__);

// Prepare $winners var for db_query
for ($k = 0; $k < $numWinners; $k++)
    if ($k + 1 < $numWinners)
        $winTickets .= $winners[$k]['ticket'].',';
    else
        $winTickets .= $winners[$k]['ticket'];

// Store winning numbers to SQL
db_query("INSERT INTO {$db_prefix}lottery_win 
(`ID_DRAWING`, `time`, `lastTicket`, `ball1`, `ball2`, `ball3`, `ball4`, `winningTickets`, `jackpotWon`) VALUES 
('', '".$currentTime."', '$lastTicket', '{$winning[1]}', '{$winning[2]}', '{$winning[3]}', '{$winning[4]}', '$winTickets', '$jackpot')",__FILE__,__LINE__);

?>