<?php
//File: Lottery.php
//      Lottery feature. Item script

//VERSION: 1.0
//DATE: Oct 17th, 2007
// $Id: Lottery.php YamiKaitou $


if (!defined('SMF'))
	die('Hacking attempt...');


class item_Lottery extends itemTemplate
{
	function getItemDetails()
	{
		$this->authorName = 'YamiKaitou';
		$this->authorEmail = 'webmaster@projectyami.com';
		$this->authorWeb = 'http://projectyami.com';
		$this->name = "Lottery Ticket";
		$this->desc = "Lottery system";
		$this->price = 1000;
		$this->require_input = true;
		$this->can_use_item = true;
		$this->delete_after_use = true;
		$this->addInput_editable = true;
	}
	
	function getAddInput()
	{
		global $item_info;
		if ($item_info[1] == 0) $item_info[1] = 5;
		if ($item_info[2] == 0) $item_info[2] = 10;
		if ($item_info[3] == 0) $item_info[3] = 50;
		if ($item_info[4] == 0) $item_info[4] = 0;
		return '<br/>
		Max number of tickets per user: <input type="text" name="info1" value="'.$item_info[1].'" /><br/>
		Range of the numbers on the balls: 1 - <input type="text" name="info2" value="'.$item_info[2].'" /><br/>
		Percentage of purchase price to be added to the jackpot (Max 100): <input type="text" name="info3" value="'.$item_info[3].'" size="2" />%<br/>
		Member ID to send the lottery win PMs from (0 will be a special guest): <input type="text" name="info4" value="'.$item_info[4].'" /><br/>
		<br/>
		<b>Important! Please leave the "Delete after use" box checked. If you uncheck it, users will be able to get free entries</b>';
	}
	
	function getUseInput()
	{
        global $item_info;
        $range = '                        <option value="null" selected>#';
        
        for ($k = 1; $k <= $item_info[2]; $k++)
            $range .= '
                        <option value="'.$k.'">'.$k;
        
        $dropdownbox = '';
        
        for ($k = 1; $k <= 4; $k++)
            $dropdownbox[$k] = '<select name="number'.$k.'">
            '.$range.'
            </select>';
        
        $displaychoices = '                <table border="0" cellpadding="5">';
        
        for ($k = 1; $k <= 4; $k++)
            $displaychoices .= '
                    <tr>
                        <td>Ball #'.$k.'</td><td>'.$dropdownbox[$k].'</td>
                    </tr>';
        
        $displaychoices .= '
                </table>
                ';
        
		return '<br/>
		Thank you for purchasing a ticket. Please select your numbers below.<br/>
		<br/>
		'.$displaychoices;
	}

	function onUse()
	{
		global $db_prefix, $ID_MEMBER, $item_info;
		
		if ($item_info[3] > 100)
            $item_info[3] = 100;
        
        for ($k = 1; $k <= 4; $k++)
        {
            if (!isset($_POST["number$k"]) OR $_POST["number$k"] == null)
                die('ERROR: You didn\'t choose a number for ball '.$k);
            
            if (!is_numeric($_POST["number$k"]))
                die('ERROR: Hacking attempt...');
            
            if ($_POST["number$k"] < 1 OR $_POST["number$k"] > $item_info[2])
                die('ERROR: Your choice has to be within the range of 1 - '.$item_info[2]);
            
            $ball[$k] = $_POST["number$k"];
        }
        
        $ball[0] = 0;
        
        if ($ball[1] == $ball[2] OR $ball[1] == $ball[3] OR $ball[1] == $ball[4] OR $ball[2] == $ball[3] OR $ball[2] == $ball[4] OR $ball[3] == $ball[4])
            die('ERROR: Each of your choices must be different from the others. IE, your choice for Ball 1 and Ball 2 can\'t both be 5.');
        
        $result = db_query("SELECT `lastTicket` FROM {$db_prefix}lottery_win ORDER BY `ID_DRAWING` DESC",__FILE__,__LINE__);
        if (mysql_num_rows($result) == 0)
            $lastTicket = 0;
        else
            $lastTicket = mysql_result($result,0);
        mysql_free_result($result);
        
        $result = db_query("SELECT `MemberTicketID` FROM `{$db_prefix}shop_lottery` WHERE
        `ID_MEMBER` = '$ID_MEMBER' AND 
        `ID_TICKET` > $lastTicket",__FILE__,__LINE__);
        if (mysql_num_rows($result) == $item_info[1])
        {
            die('ERROR: Sorry, but you are only allowed to enter '.$item_info[1].' ticket(s) per drawing.');
        }
        
        array_multisort($ball,SORT_ASC);
        
        $k = mysql_num_rows($result) + 1;
		db_query("INSERT INTO {$db_prefix}shop_lottery
		(`ID_TICKET`, `ID_MEMBER`, `MemberTicketID`, `Ball1`, `Ball2`, `Ball3`, `Ball4`) VALUES
		('', $ID_MEMBER, $k, {$ball[1]}, {$ball[2]}, {$ball[3]}, {$ball[4]})",__FILE__,__LINE__);
        mysql_free_result($result);
        $result = db_query("SELECT `value` FROM {$db_prefix}settings WHERE `variable` = 'lottery_pot'",__FILE__,__LINE__);
        $jackpot = mysql_result($result,0);
        mysql_free_result($result);
        $result = db_query("SELECT `price` FROM {$db_prefix}shop_items WHERE `module` = 'Lottery'",__FILE__,__LINE__);
        $jackpot += (mysql_result($result,0) * ($item_info[3] / 100));
        db_query("UPDATE {$db_prefix}settings SET `value` = $jackpot WHERE `variable` = 'lottery_pot'",__FILE__,__LINE__);
		
		return 'Your ticket has successfully been entered into the next lottery drawing. Estimated Jackpot is '.$jackpot;
	}
}
	
?>