<?php
//File: LotterySQL.php
//      Lottery feature. SQL install script

//VERSION: 1.0
//DATE: Oct 17th, 2007
// $Id: LotterySQL.php YamiKaitou $


if (file_exists(dirname(__FILE__) . '/SSI.php') && !defined('SMF'))
	require_once(dirname(__FILE__) . '/SSI.php');
// Hmm... no SSI.php and no SMF?
elseif (!defined('SMF'))
	die('<b>Error:</b> Cannot install - please verify you put this in the same place as SMF\'s index.php.');

// Create table that stores members tickets
db_query("CREATE TABLE IF NOT EXISTS {$db_prefix}shop_lottery (
`ID_TICKET` MEDIUMINT( 8 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,
`ID_MEMBER` MEDIUMINT( 8 ) NOT NULL ,
`MemberTicketID` TINYINT( 1 ) NOT NULL ,
`Ball1` MEDIUMINT( 5 ) NOT NULL ,
`Ball2` MEDIUMINT( 5 ) NOT NULL ,
`Ball3` MEDIUMINT( 5 ) NOT NULL ,
`Ball4` MEDIUMINT( 5 ) NOT NULL
)",__FILE__,__LINE__);

// Create table that stores the drawing data
db_query("CREATE TABLE IF NOT EXISTS {$db_prefix}lottery_win (
  `ID_DRAWING` mediumint(5) NOT NULL auto_increment,
  `time` varchar(15) NOT NULL default '',
  `lastTicket` mediumint(5) NOT NULL default '0',
  `ball1` mediumint(3) NOT NULL default '0',
  `ball2` mediumint(3) NOT NULL default '0',
  `ball3` mediumint(3) NOT NULL default '0',
  `ball4` mediumint(3) NOT NULL default '0',
  `winningTickets` text NOT NULL,
  `jackpotWon` text NOT NULL,
  PRIMARY KEY  (`ID_DRAWING`)
)",__FILE__,__LINE__);

// Add a place to store the jackpot. Start jackpot off at 1000 just because I want to
db_query("INSERT INTO {$db_prefix}settings (`variable`, `value`) VALUES ('lottery_pot', '1000')",__FILE__,__LINE__);

// Add a place to store when the last drawing took place. Prevents drawings from happening to close to each other
db_query("INSERT INTO {$db_prefix}settings (`variable`, `value`) VALUES ('lottery_last_draw', '".time()."')",__FILE__,__LINE__);

?>